# -*- coding: utf-8 -*-

#3a) Si sviluppi una funzione split_by_type(loe, f=type) che, data in ingresso
# una lista di elementi, restituisca una lista di liste in cui ciascuna 
# sottolista contenga gli elementi dello stesso tipo in "loe", nello stesso 
# ordine relativo con cui compaiono in "loe". La funzione che permette di 
# definire il tipo dell'elemento sia l'argomento "f", che ha come default 
# la funzione built-in "type".
#
# Es. 
# l = ['ciao', 3, 7.1, '3', '7.1', (1, 2)]
# split_by_type(l)          # -> [['ciao', '3', '7.1'], [3], [7.1], [(1, 2)]]
# split_by_type(l, str)     # -> [['ciao'], [3, '3'], [7.1, '7.1'], [(1, 2)]]
# split_by_type([1, 2, 3])  # -> [[1, 2, 3]]


def split_by_type(loe, f=type):
    """
    Given a list "loe" whose elements may be of different types, it returns 
    a list of lists, each grouping all the elements of the same type. 
    In the result, the elements in each sublist are in the same relative order 
    as in "loe".
    The function f (default to "type") is used to determine the (possibly 
    custom) type of an element.
    """
    mydict={}
    mytypes=[]
    for e in loe:
        t=f(e)
        if t in mydict:
            mydict[t].append(e)
        else:
            mydict[t]=[e]
            mytypes.append(t)
    return [mydict[t] for t in mytypes]
            