# -*- coding: utf-8 -*-

#2b) Utilizzando la funzione sviluppata al punto 2a), si stabilisca per 
# ciascuna delle stringhe presenti su righe distinte del file "assorted.txt" 
# quali sono gli alfabeti standard di dimensione minima che siano compatibili 
# con esse.
# Si scelga la prima stringa a cui è associato un solo alfabeto standard valido, 
# se ne costruisca la corrispondente sequenza di tipo Bio.Seq.Seq e, dopo 
# averne ottenuto il corrispondente Bio.SeqIO.SeqRecord, si stampi la sua 
# rappresentazione fasta sul file uso2.txt.
# Non si specifichi nessun id/descrizione per la sequenza.
# Per ottenere le istanze degli alfabeti standard in Biopython a partire dai 
# nomi degli alfabeti, si può usare il dizionario definito nel file utils.py.


from soluzione1 import file2list
from soluzione2 import fitting_alpha
from utils import alphabyname
import Bio.Seq as Seq
import Bio.SeqIO as SeqIO

infile = "assorted.txt"
outfile = "uso2.txt"

seqs = file2list(infile)

for s in seqs:
    alphas = fitting_alpha(s)
    if len(alphas) == 1:
        s_alpha_name = alphas[0]
        if s_alpha_name != "unknown":
            break
 
myseqrecord = SeqIO.SeqRecord(Seq.Seq(s, alphabyname[s_alpha_name]))

with open(outfile, "w") as f:
    SeqIO.write([myseqrecord], f, "fasta")
